#TEMPLATE(SingleFileTree,'Create tree-control for single file'), FAMILY('ABC')
#GROUP(%ConvertName,%ConvertField)
#IF(INSTRING('[', %ConvertField, 1, 1))
  #INSERT(%ReplaceCharacter(ABC), '[', '_')
  #INSERT(%ReplaceCharacter(ABC), ',', '_')
  #INSERT(%ReplaceCharacter(ABC), ']', '')
  #SET(%ConvertField,%ValueConstruct)
#ENDIF
#GROUP(%AddIconToPopup,%ProcessedControl,%ListControl,%CurrentIcon,%ModeAddIcon)
#CASE(%ModeAddIcon)
#OF('  ')
  #INSERT(%AddControlIconToPopup,%ProcessedControl,%ListControl)
#OF('')
  #INSERT(%AddNonControlIconToPopup,%CurrentIcon)
#OF(' ')
  #SET(%ValueConstruct,'''''')
#ELSE
  #SET(%ValueConstruct,'''''')
#ENDCASE
#!-------------------------------------------------------------------------
#GROUP(%AddControlIconToPopup,%ProcessedControl,%ListControl)
#FIX(%Control,%ProcessedControl)
#SET(%ValueConstruct,EXTRACT(%ControlStatement,'ICON'))
#IF(%ValueConstruct)
  #IF(UPPER(SUB(%ValueConstruct,6,5)) = 'ICON:')
    #SET(%ValueConstruct,'''[''' & ' & PROP:Icon & ' & '''('' & ' & %ProcessedControl & '{PROP:Icon} & ' & ''')]''')
  #ELSE
    #SET(%ValueConstruct,'''[''' & ' & PROP:Icon & ' & '''(~'' & ' & %ProcessedControl & '{PROP:Icon} & ' & ''')]''')
  #ENDIF
#ELSE
  #SET(%ValueConstruct,'''''')
#ENDIF
#FIX(%Control,%ListControl)
#!-------------------------------------------------------------------------
#GROUP(%AddNonControlIconToPopup,%CurrentIcon)
#IF(%CurrentIcon)
  #IF(UPPER(SUB(%CurrentIcon,1,5)) = 'ICON:' OR SUB(%CurrentIcon,LEN(CLIP(%CurrentIcon)),1) = ']')
    #SET(%ValueConstruct,'''[''' & ' & PROP:Icon & ' & '''('' & ''' & %CurrentIcon & ''' & '')]''')
  #ELSE
    #SET(%ValueConstruct,'''[''' & ' & PROP:Icon & ' & '''(~'' & ''' & %CurrentIcon & ''' & '')]''')
  #ENDIF
#ELSE
  #SET(%ValueConstruct,'''''')
#ENDIF
#!-------------------------------------------------------------------------
#CONTROL(SingleFileTree,'     '),PRIMARY(' ',OPTKEY),DESCRIPTION('  ' & %Primary),MULTI,WINDOW
  CONTROLS
    LIST,AT(,,150,100),USE(?FileTree),FORMAT('800Lt@s200@'),FROM(Queue:SingleFileTree)
  END
#BUTTON('& '),AT(10,,180)
  #SHEET,ADJUST
    #TAB('&')
      #PREPARE
        #FIND(%ControlInstance,%ActiveTemplateInstance,%Control)
      #ENDPREPARE
      #BOXED(' '),AT(,40)
        #PROMPT('  :',@S255),%TreeTitle
        #ENABLE(%ControlHasIcon AND %TreeTitle)
          #PROMPT(' :',OPENDIALOG(' ','Icons- (*.ICO)|*.ICO|Windows Bitmaps- (*.BMP)|*.BMP|  (*.*)|*.*')),%TreeTitleIcon
        #ENDENABLE
      #ENDBOXED
      #PROMPT('&  :',FIELD),%DisplayTree,REQ
      #PROMPT('& :',@S255),%FilterTree
      #BOXED('/ ')
        #BOXED(' ')
          #PROMPT('& :',KEYCODE),%ExpandKeyCode,DEFAULT('PlusKey')
          #PROMPT('& :',KEYCODE),%ContractKeyCode,DEFAULT('MinusKey')
        #ENDBOXED
        #PROMPT(' ""   / ',CHECK),%WaitCursorExpandContractLevel,AT(10)
      #ENDBOXED
    #ENDTAB
    #TAB('&   ')
      #PREPARE
        #FIND(%ControlInstance,%ActiveTemplateInstance,%Control)
        #FIX(%File,%Primary)
        #FIX(%Driver,%FileDriver)
      #ENDPREPARE
      #BOXED(''),AT(,40)
        #PROMPT('&-ID :',FIELD(%Primary)),%MainField,REQ
        #DISPLAY('       ')
        #DISPLAY('    .')
      #ENDBOXED
      #BOXED('')
        #PROMPT('-&   ID:',KEY(%Primary)),%ChildKey,REQ
        #DISPLAY('1.       ')
        #DISPLAY(' -ID   .')
        #DISPLAY('2.       OPT')
        #DISPLAY('(    "Exclude Empty Keys").')
        #ENABLE(%DriverSQL)
          #DISPLAY('')
          #DISPLAY(' ,  SQL-,')
          #DISPLAY(',     !')
        #ENDENABLE
      #ENDBOXED
    #ENDTAB
    #TAB('&')
      #PREPARE
        #FIND(%ControlInstance,%ActiveTemplateInstance,%Control)
      #ENDPREPARE
      #BOXED('  '),AT(,40)
        #PROMPT('   ',CHECK),%EnableMoveBranch,AT(10)
        #ENABLE(%EnableMoveBranch)
          #DISPLAY('   :')
          #DISPLAY('1.    ,')
          #DISPLAY('      .')
          #DISPLAY('2.  CtrlLeftMouse   ,')
          #DISPLAY('         .')
        #ENDENABLE
      #ENDBOXED
      #BOXED(' ')
        #PROMPT('  :',DROP(' | ')),%InitTreeType,DEFAULT(' ')
        #ENABLE(%InitTreeType = ' '),CLEAR
          #PROMPT('     ',CHECK),%InitTreeSetPos,AT(10)
        #ENDENABLE
      #ENDBOXED
    #ENDTAB
    #TAB('"&" ')
      #PREPARE
        #FIND(%ControlInstance,%ActiveTemplateInstance,%Control)
      #ENDPREPARE
      #BUTTON('"&" '),MULTI(%HotFields,%HotField),AT(,40),INLINE,HLP('~TPLControlBrowseBox_Hot_Fields')
        #PROMPT('"&" :',FIELD),%HotField,REQ
      #ENDBUTTON
    #ENDTAB
    #TAB('&'),WHERE(%ControlHasColor)
      #PREPARE
        #FIND(%ControlInstance,%ActiveTemplateInstance,%Control)
      #ENDPREPARE
      #BOXED(' '),AT(,40)
        #PROMPT(' &:',COLOR),%DefaultForegroundNormal,DEFAULT(-1)
        #PROMPT(' &:',COLOR),%DefaultBackgroundNormal,DEFAULT(-1)
        #PROMPT(' &:',COLOR),%DefaultForegroundSelected,DEFAULT(-1)
        #PROMPT(' &:',COLOR),%DefaultBackgroundSelected,DEFAULT(-1)
      #ENDBOXED
      #BOXED(' ')
        #BUTTON('& '),MULTI(%ConditionalColors,%ColorCondition),INLINE,AT(,,,90)
          #PROMPT('&:',@S255),%ColorCondition,DEFAULT('Queue:SingleFileTree.TSF'& %ActiveTemplateInstance &':Loaded')
          #PROMPT('&    :',@S255),%ColorConditionProc,AT(,22),PROMPTAT(,,,16),DEFAULT('QueueTree.TSF' & %ActiveTemplateInstance &':Loaded')
          #PROMPT(' &:',COLOR),%ConditionalForegroundNormal,DEFAULT(-1)
          #PROMPT(' &:',COLOR),%ConditionalBackgroundNormal,DEFAULT(-1)
          #PROMPT(' &:',COLOR),%ConditionalForegroundSelected,DEFAULT(-1)
          #PROMPT(' &:',COLOR),%ConditionalBackgroundSelected,DEFAULT(-1)
        #ENDBUTTON
      #ENDBOXED
    #ENDTAB
    #TAB('&'),WHERE(NOT %ControlHasColor)
      #PREPARE
        #FIND(%ControlInstance,%ActiveTemplateInstance,%Control)
      #ENDPREPARE
      #DISPLAY('  SingleFileTree   .    ,   .'),AT(10,40,175,24)
      #DISPLAY('1.        ,  .'),AT(10,,175,16)
      #DISPLAY('2.       SingleFileTree,   "List Box Format...".'),AT(10,,175,16)
      #DISPLAY('3.    SingleFileTree,    ,    "Properties".'),AT(10,,175,16)
      #DISPLAY('4.   checkbox "Color cells".'),AT(10,,175)
      #DISPLAY('5.     SingleFileTree-actions ,     ,   .'),AT(10,,175,24)
    #ENDTAB
    #TAB('&'),WHERE(%ControlHasIcon)
      #PREPARE
        #FIND(%ControlInstance,%ActiveTemplateInstance,%Control)
      #ENDPREPARE
      #BOXED(' '),AT(,40)
        #PROMPT('& :',OPENDIALOG(' ','Icons- (*.ICO)|*.ICO|Windows Bitmaps- (*.BMP)|*.BMP|  (*.*)|*.*')),%DefaultIcon
      #ENDBOXED
      #BOXED(' ')
        #BUTTON('& '),MULTI(%ConditionalIcons,%IconCondition),INLINE
          #PROMPT('&:',@S255),%IconCondition,DEFAULT('Queue:SingleFileTree.TSF'& %ActiveTemplateInstance &':Loaded')
          #PROMPT('&    :',@S255),%IconConditionProc,AT(,22),PROMPTAT(,,,16),DEFAULT('QueueTree.TSF' & %ActiveTemplateInstance &':Loaded')
          #PROMPT('&:',OPENDIALOG(' ','Icons- (*.ICO)|*.ICO|Windows Bitmaps- (*.BMP)|*.BMP|  (*.*)|*.*')),%ConditionalIcon
        #ENDBUTTON
      #ENDBOXED
    #ENDTAB
    #TAB('&'),WHERE(NOT %ControlHasIcon)
      #PREPARE
        #FIND(%ControlInstance,%ActiveTemplateInstance,%Control)
      #ENDPREPARE
      #DISPLAY('  SingleFileTree   .    ,   .'),AT(10,40,175,24)
      #DISPLAY('1.        ,  .'),AT(10,,175,16)
      #DISPLAY('2.       SingleFileTree,   "List Box Format...".'),AT(10,,175,16)
      #DISPLAY('3.    SingleFileTree,      ,    "Properties".'),AT(10,,175,24)
      #DISPLAY('4.   checkbox "Icons".'),AT(10,,175)
      #DISPLAY('5.     SingleFileTree-actions ,     ,     .'),AT(10,,175,24)
    #ENDTAB
#!  *** KreatoR *** 
    #TAB('&')
      #PREPARE
        #FIND(%ControlInstance,%ActiveTemplateInstance,%Control)
      #ENDPREPARE
      #BOXED(' ')
        #PROMPT('&:',@S255),%MyInstancePrefix,DEFAULT('TSF'& %ActiveTemplateInstance)
      #ENDBOXED
    #ENDTAB
  #ENDSHEET
#ENDBUTTON
#CLASS('Format Single File Tree','   ' & %ActiveTemplateInstanceDescription)
#AT(%CustomGlobalDeclarations)
  #INSERT(%FileControlSetFlags(ABC))
  #FOR(%Control),WHERE(%ControlInstance = %ActiveTemplateInstance)
    #IF(%ControlHasIcon)
      #IF(%TreeTitleIcon)
        #INSERT(%StandardAddIconToProject(ABC),%TreeTitleIcon)
      #ENDIF
      #IF(%DefaultIcon)
        #INSERT(%StandardAddIconToProject(ABC),%DefaultIcon)
      #ENDIF
      #FOR(%ConditionalIcons)
        #INSERT(%StandardAddIconToProject(ABC),%ConditionalIcon)
      #ENDFOR
    #ENDIF
  #ENDFOR
#ENDAT
#ATSTART
#MESSAGE('  ',3)
#INSERT(%FileControlInitialize(ABC))
#INSERT(%SingleFileTreeCommonDeclarations)
#DECLARE(%BranchQueue)
#DECLARE(%IconList),UNIQUE
#DECLARE(%IconListType,%IconList)
#DECLARE(%CurrentDriverIsSQL)
#FIX(%Control,%TreeControl)
#IF(%ControlHasIcon)
  #IF(%TreeTitleIcon)
    #INSERT(%AddBrowseIcon(ABC),%TreeTitleIcon)
  #ENDIF
  #IF(%DefaultIcon)
    #INSERT(%AddBrowseIcon(ABC),%DefaultIcon)
  #ENDIF
  #FOR(%ConditionalIcons)
    #INSERT(%AddBrowseIcon(ABC),%ConditionalIcon)
  #ENDFOR
#ENDIF
#SET(%BranchQueue,%InstancePrefix & ':BranchQueue')
#FIX(%File,%Primary)
#FIX(%Driver,%FileDriver)
#IF(%DriverSQL)
  #SET(%CurrentDriverIsSQL,%True)
  #FIX(%Key,%ChildKey)
  #IF(%KeyDuplicate)
    #ERROR(' , ' & %Primary & '  SQL-, ,   ' & %ChildKey & '  ')
  #ENDIF
#ELSE
  #SET(%CurrentDriverIsSQL,%False)
#ENDIF
#ENDAT
#!-------------------------------------------------------------------------
#AT(%CustomModuleDeclarations)
  !!Beg
  #FOR(%ModuleProcedure)
    !!%ActiveTemplate
    #FIX(%Procedure,%ModuleProcedure)
    #FOR(%ActiveTemplate),WHERE(%ActiveTemplate='SingleFileTree(SingleFileTree)') #!SingleFileTree(ABC)')
      !!
      #FOR(%ActiveTemplateInstance)
        #CONTEXT(%Procedure,%ActiveTemplateInstance)
          #IF(VAREXISTS(%TreeTypeDeclare))
            #CYCLE
          #ELSE
            #EQUATE(%TreeTypeDeclare,%True)
          #ENDIF
#EMBED(%ModuleDataSectionSingleFileTree,'Single File Tree -    '),%ActiveTemplateInstance,MAP(%ActiveTemplateInstance,%ActiveTemplateinstanceDescription),DATA          #! Embedded Source Code
  #IF(NOT VAREXISTS(%InstancePrefix))
    #INSERT(%SingleFileTreeCommonDeclarations)
  #ENDIF
  #FIX(%File,%Primary)
  #FIX(%Field,%MainField)
  #ADD(%CustomModuleMapModule,'CURRENT MODULE')
  #ADD(%CustomModuleMapProcedure,' '& %RecursiveProcedureLoadLevel)
  #SET(%CustomModuleMapProcedurePrototype,'(' & %InstancePrefix & 'QueueTreeType, ' & %InstancePrefix & 'LoadedTreeQueueType, ' & %FieldType & ' ' & %MainFieldID & ', LONG CurrentLevel, BYTE NeedExpand)')
  #ADD(%CustomModuleMapModule,'CURRENT MODULE')
  #ADD(%CustomModuleMapProcedure,' '& %TestPresentSubLevelProcedure)
  #SET(%CustomModuleMapProcedurePrototype,'(' &  %FieldType & ' ' & %MainFieldID & '),LONG')
  #SET(%ValueConstruct,%InstancePrefix & 'QueueTreeType')
%[20]ValueConstruct QUEUE,TYPE                      #<! Browsing Queue
  #SET(%ValueConstruct,%InstancePrefix & ':Display')
%[20]ValueConstruct STRING(2000)                 #<! Queue position of scroll thumb
  #FIX(%Control,%TreeControl)
  #SELECT(%ControlField,1)
  #IF(%ControlHasColor)
    #SET(%ValueConstruct,%InstancePrefix & ':NormalFG')
%[20]ValueConstruct LONG
    #SET(%ValueConstruct,%InstancePrefix & ':NormalBG')
%[20]ValueConstruct LONG
    #SET(%ValueConstruct,%InstancePrefix & ':SelectedFG')
%[20]ValueConstruct LONG
    #SET(%ValueConstruct,%InstancePrefix & ':SelectedBG')
%[20]ValueConstruct LONG
  #ENDIF
  #IF(%ControlHasIcon)
    #SET(%ValueConstruct,%InstancePrefix & ':Icon')
%[20]ValueConstruct SHORT
  #ENDIF
  #SET(%ValueConstruct,%InstancePrefix & ':Level')
%[20]ValueConstruct LONG                        #<!  <255>
  #SET(%ValueConstruct,%InstancePrefix & ':Loaded')
%[20]ValueConstruct BYTE                        #<! 0- ,1- 
  #SET(%ValueConstruct,%InstancePrefix & ':' & %MainFieldID)
%[20]ValueConstruct LIKE(%MainField)
  #SET(%ValueConstruct,%InstancePrefix & ':' & %ChildFieldID)
%[20]ValueConstruct LIKE(%ChildField)
  #SET(%ValueConstruct,%InstancePrefix & ':Position')
%[20]ValueConstruct STRING(2000)
  #FOR(%HotFields)
    #SET(%ValueConstruct,%HotField)
    #INSERT(%ConvertName,%ValueConstruct)
    #SET(%ValueConstruct,%InstancePrefix & ':' & %ValueConstruct)
%[20]ValueConstruct LIKE(%HotField)
  #ENDFOR
                END
#!-------------------------------------------------------------
  #SET(%ValueConstruct,%InstancePrefix & 'LoadedTreeQueueType')
%[20]ValueConstruct QUEUE,TYPE                 #<! Status Queue
  #SET(%ValueConstruct,%InstancePrefix & ':LoadedLevel')
%[20]ValueConstruct LONG                        #<! Queue position of scroll thumb
  #SET(%ValueConstruct,%InstancePrefix & ':Loaded' & %MainFieldID)
%[20]ValueConstruct LIKE(%MainField)
               END
        #ENDCONTEXT
      #ENDFOR
    #ENDFOR
  #ENDFOR
!!End
#ENDAT
#!--------------------------------------------------------------------
#AT(%DataSectionBeforeWindow)
  #DECLARE(%TempValue)
  #SET(%ValueConstruct,%InstancePrefix & 'QueueTreeType')
%[20]TreeQueue QUEUE(%ValueConstruct)    #<! Browsing Queue
               END
%[20]BranchQueue QUEUE(%ValueConstruct)    #<! Browsing Queue
               END
  #SET(%ValueConstruct,%InstancePrefix & ':LoadedTreeQueue')
  #SET(%TempValue,%InstancePrefix & 'LoadedTreeQueueType')
%[20]ValueConstruct QUEUE(%TempValue)     #<! Status Queue
               END
  #SET(%ValueConstruct,%InstancePrefix & ':LoadedBranchQueue')
%[20]ValueConstruct QUEUE(%TempValue)     #<! Status Queue
               END
  #SET(%ValueConstruct,%InstancePrefix & ':CurrentLevel')
%[20]ValueConstruct LONG                        #<! Queue position of scroll thumb
  #SET(%ValueConstruct,%InstancePrefix & ':CurrentChoice')
%[20]ValueConstruct LONG                        #<! Queue position of scroll thumb
#IF(%EnableMoveBranch)
  #SET(%ValueConstruct,%InstancePrefix & ':OldChoice')
%[20]ValueConstruct LONG
  #SET(%ValueConstruct,%InstancePrefix & ':MoveBranch')
%[20]ValueConstruct BYTE
#ENDIF
  #SET(%ValueConstruct,%InstancePrefix & ':PresentSubLevel')
%[20]ValueConstruct BYTE
  #SET(%ValueConstruct,%InstancePrefix & ':Save:' & %MainFieldID)
%[20]ValueConstruct LIKE(%MainField)
  #SET(%ValueConstruct,%InstancePrefix & ':PopupText')
%[20]ValueConstruct STRING(512)
#ENDAT
#!-------------------------------------------------------------------------
#AT(%WindowInitializationCode)
#CASE(%InitTreeType)
#OF(' ')
DO %InstancePrefix:ContractAll
%TreeControl{Prop:Selected} = 1
  #IF(%TreeTitle)
%InstancePrefix:CurrentChoice = 1
  #ENDIF
#OF(' ')
DO %InstancePrefix:ExpandAll
  #IF(%InitTreeSetPos)
DISPLAY()
IF %InstancePrefix:Save:%MainFieldID
  %TreeQueue.%InstancePrefix:%MainFieldID = %InstancePrefix:Save:%MainFieldID
  GET(%TreeQueue,+%TreeQueue.%InstancePrefix:%MainFieldID)
  %InstancePrefix:CurrentChoice = POINTER(%TreeQueue)
  %TreeControl{Prop:Selected} = %InstancePrefix:CurrentChoice
ELSE
  %TreeControl{Prop:Selected} = 1
    #IF(%TreeTitle)
  %InstancePrefix:CurrentChoice = 1
    #ENDIF
END
  #ELSE
%TreeControl{Prop:Selected} = 1
    #IF(%TreeTitle)
%InstancePrefix:CurrentChoice = 1
    #ENDIF
  #ENDIF
#ENDCASE
#ENDAT
#!-------------------------------------------------------------------------
#AT(%AfterWindowOpening)
#FIX(%Control,%TreeControl)
#IF(%InitTreeType = ' ' AND %InitTreeSetPos)
%InstancePrefix:Save:%MainFieldID = %MainField
#ENDIF
#IF(%ControlHasIcon)
  #FOR(%IconList),WHERE(%IconListType <> 'Variable')
    #SET(%ValueConstruct,INSTANCE(%IconList))
    #IF(%IconListType = 'Built-In')
%TreeControl{Prop:IconList,%ValueConstruct} = %IconList
    #ELSIF(%IconListType = 'File')
%TreeControl{Prop:IconList,%ValueConstruct} = '~%IconList'
    #ELSIF(%IconListType = 'External')
%TreeControl{Prop:IconList,%ValueConstruct} = '%IconList'
    #ENDIF
  #ENDFOR
#ENDIF
#ENDAT
#!-------------------------------------------------------------------------
#AT(%PrepareAlerts)
#IF(%ExpandKeyCode)
%TreeControl{Prop:Alrt,255} = %ExpandKeyCode
#ELSE
%TreeControl{Prop:Alrt,255} = PlusKey
#ENDIF
#IF(%ContractKeyCode)
%TreeControl{Prop:Alrt,254} = %ContractKeyCode
#ELSE
%TreeControl{Prop:Alrt,254} = MinusKey
#ENDIF
%TreeControl{Prop:Alrt,256} = RightKey
%TreeControl{Prop:Alrt,257} = LeftKey
#ENDAT
#!-------------------------------------------------------------------------
#AT(%ControlEventHandling,%TreeControl,'NewSelection')
DO %InstancePrefix:NewSelection
#ENDAT
#!-------------------------------------------------------------------------
#AT(%ControlEventHandling,%TreeControl,'AlertKey')
CASE KEYCODE()
#IF(%ExpandKeyCode)
OF %ExpandKeyCode
#ELSE
OF PlusKey
#ENDIF
OROF RightKey
  %TreeControl{PropList:MouseDownRow} = CHOICE(%TreeControl)
  POST(Event:Expanded,%TreeControl)
#IF(%ContractKeyCode)
OF %ContractKeyCode
#ELSE
OF MinusKey
#ENDIF
OROF LeftKey
  %TreeControl{PropList:MouseDownRow} = CHOICE(%TreeControl)
  POST(Event:Contracted,%TreeControl)
OF MouseLeft2
  #EMBED(%AlertKeySingleFileTreeDoubleClick,' AlertKey = MouseLeft2'),HIDE
#EMBED(%AlertKeySingleFileTree,' AlertKey'),HIDE
END
#ENDAT
#!-------------------------------------------------------------------------
#AT(%ControlEventHandling,%TreeControl,'Expanded')
#IF(%WaitCursorExpandContractLevel)
SETCURSOR(CURSOR:Wait)
#ENDIF
DO %InstancePrefix:ExpandLevel
#IF(%WaitCursorExpandContractLevel)
SETCURSOR()
#ENDIF
SELECT(%TreeControl,%TreeControl{PropList:MouseDownRow})
DO %InstancePrefix:NewSelection
#ENDAT
#!-------------------------------------------------------------------------
#AT(%ControlEventHandling,%TreeControl,'Contracted')
#IF(%WaitCursorExpandContractLevel)
SETCURSOR(CURSOR:Wait)
#ENDIF
DO %InstancePrefix:ContractLevel
#IF(%WaitCursorExpandContractLevel)
SETCURSOR()
#ENDIF
SELECT(%TreeControl,%TreeControl{PropList:MouseDownRow})
DO %InstancePrefix:NewSelection
#ENDAT
#!-------------------------------------------------------------------------
#AT(%ControlEventHandling,%TreeControl,'Accepted'),WHERE(%EnableMoveBranch)
IF KEYCODE() = CtrlMouseLeft OR KEYCODE() = 529
  DO %InstancePrefix:MovingBranch
END
#ENDAT
#!-------------------------------------------------------------------------
#!#AT(%WindowEventHandling,'GainFocus')     *** KreatoR ***
#!DO %InstancePrefix:RefreshTree
#!#ENDAT
#!-------------------------------------------------------------------------
#AT(%SyncWindowAfterLookup)
#IF(%TreeTitle)
IF RECORDS(%TreeQueue) > 1
#ELSE
IF RECORDS(%TreeQueue)
#ENDIF
  %InstancePrefix:CurrentChoice = CHOICE(%TreeControl)
  GET(%TreeQueue,%InstancePrefix:CurrentChoice)
#IF(%CurrentDriverIsSQL)
  REGET(%ChildKey,%TreeQueue.%InstancePrefix:Position)
#ELSE
  REGET(%Primary,%TreeQueue.%InstancePrefix:Position)
#ENDIF
END
#ENDAT
#!-------------------------------------------------------------------------
#AT(%ControlOtherEventHandling,%TreeControl)
#SET(%ValueConstruct,%True)
#FOR(%ControlEvent),WHERE(%ControlEvent = 'AlertKey')
  #SET(%ValueConstruct,%False)
#ENDFOR
#IF(%ValueConstruct)
CASE EVENT()
OF Event:AlertKey
  CASE KEYCODE()
  #IF(%ExpandKeyCode)
  OF %ExpandKeyCode
  #ELSE
  OF PlusKey
  #ENDIF
  OROF RightKey
    %TreeControl{PropList:MouseDownRow} = CHOICE(%TreeControl)
    POST(Event:Expanded,%TreeControl)
  #IF(%ContractKeyCode)
  OF %ContractKeyCode
  #ELSE
  OF MinusKey
  #ENDIF
  OROF LeftKey
    %TreeControl{PropList:MouseDownRow} = CHOICE(%TreeControl)
    POST(Event:Contracted,%TreeControl)
  OF MouseLeft2
    #EMBED(%AlertKeySingleFileTreeDoubleClick,' AlertKey = MouseLeft2'),HIDE
  #EMBED(%AlertKeySingleFileTree,' AlertKey'),HIDE
  END
END
#ENDIF
#ENDAT
#!-------------------------------------------------------------------------
#AT(%ProcedureRoutines)
#FIX(%File,%Primary)
#FIX(%Field,%MainField)
#FIX(%Control,%TreeControl)
!------------------------------------------------------
%InstancePrefix:InitTree ROUTINE
  FREE(%TreeQueue)
  #IF(%TreeTitle)
  #INSERT(%StandardValueAssignment(ABC),%TreeQueue & '.' & %InstancePrefix & ':Display',%TreeTitle)
  CLEAR(%TreeQueue.%InstancePrefix:%MainFieldID)
  CLEAR(%TreeQueue.%InstancePrefix:%ChildFieldID)
  %TreeQueue.%InstancePrefix:Level = 0
  %TreeQueue.%InstancePrefix:Position = ''
    #IF(%ControlHasIcon)
      #FIX(%IconList,%TreeTitleIcon)
      #IF(%IconList)
      #CASE(%IconListType)
        #OF('Variable')
  %TreeQueue.%InstancePrefix:Icon = %IconList
        #ELSE
          #SET(%ValueConstruct,INSTANCE(%IconList))
  %TreeQueue.%InstancePrefix:Icon = %ValueConstruct
        #ENDCASE
      #ELSE
  %TreeQueue.%InstancePrefix:Icon = 0
      #ENDIF
    #ENDIF
    #IF(%ControlHasColor)
  %TreeQueue.%InstancePrefix:NormalFG = -1
  %TreeQueue.%InstancePrefix:NormalBG = -1
  %TreeQueue.%InstancePrefix:SelectedFG = -1
  %TreeQueue.%InstancePrefix:SelectedBG = -1
    #ENDIF
  ADD(%TreeQueue)
  #ENDIF
!------------------------------------------------------
%InstancePrefix:ContractAll ROUTINE
  #EMBED(%BeforeExpConSingleFileTree,' / '),%ActiveTemplateInstance,MAP(%ActiveTemplateInstance,%ActiveTemplateinstanceDescription),HIDE
  DO %InstancePrefix:InitTree
  FREE(%InstancePrefix:LoadedTreeQueue)
  #INSERT(%SingleFileTreeDefType)
  %RecursiveProcedureLoadLevel(%TreeQueue,%InstancePrefix:LoadedTreeQueue,%ValueConstruct,0,0)
  #EMBED(%AfterExpConSingleFileTree,' / '),%ActiveTemplateInstance,MAP(%ActiveTemplateInstance,%ActiveTemplateinstanceDescription)
  IF KEYCODE() = MouseRight THEN SETKEYCODE(0).
!------------------------------------------------------
%InstancePrefix:ExpandAll ROUTINE
  #EMBED(%BeforeExpConSingleFileTree,' / '),%ActiveTemplateInstance,MAP(%ActiveTemplateInstance,%ActiveTemplateinstanceDescription),HIDE
  DO %InstancePrefix:InitTree
  FREE(%InstancePrefix:LoadedTreeQueue)
  #INSERT(%SingleFileTreeDefType)
  %RecursiveProcedureLoadLevel(%TreeQueue,%InstancePrefix:LoadedTreeQueue,%ValueConstruct,0,1)
  #EMBED(%AfterExpConSingleFileTree,' / '),%ActiveTemplateInstance,MAP(%ActiveTemplateInstance,%ActiveTemplateinstanceDescription)
  IF KEYCODE() = MouseRight THEN SETKEYCODE(0).
!------------------------------------------------------
%InstancePrefix:RefreshTree ROUTINE
  DO %InstancePrefix:InitTree
  #INSERT(%SingleFileTreeDefType)
  %RecursiveProcedureLoadLevel(%TreeQueue,%InstancePrefix:LoadedTreeQueue,%ValueConstruct,0,0)
  #EMBED(%SingleFileRefreshTree,' RefreshTree'),%ActiveTemplateInstance,MAP(%ActiveTemplateInstance,%ActiveTemplateinstanceDescription)
!------------------------------------------------------
%InstancePrefix:ContractLevel ROUTINE
  %InstancePrefix:CurrentChoice = %TreeControl{PropList:MouseDownRow}
  #IF(%TreeTitle)
  IF %InstancePrefix:CurrentChoice = 1 THEN EXIT.
  #ENDIF

  GET(%TreeQueue,%InstancePrefix:CurrentChoice)

  %InstancePrefix:PresentSubLevel = %TestPresentSubLevelProcedure(%TreeQueue.%InstancePrefix:%MainFieldID)
  IF %InstancePrefix:PresentSubLevel = 0 THEN EXIT.

#IF(%CurrentDriverIsSQL)
  REGET(%ChildKey,%TreeQueue.%InstancePrefix:Position)
#ELSE
  REGET(%Primary,%TreeQueue.%InstancePrefix:Position)
#ENDIF
#FOR(%HotFields)
  #SET(%ValueConstruct,%HotField)
  #INSERT(%ConvertName,%ValueConstruct)
  %HotField = %TreeQueue.%InstancePrefix:%ValueConstruct
#ENDFOR

  %TreeQueue.%InstancePrefix:Loaded = 0
  %TreeQueue.%InstancePrefix:Level = -ABS(%TreeQueue.%InstancePrefix:Level)
  #INSERT(%SetIconColorSingleFileTree,%TreeQueue)
  PUT(%TreeQueue)
  %InstancePrefix:LoadedTreeQueue.%InstancePrefix:Loaded%MainFieldID = %TreeQueue.%InstancePrefix:%MainFieldID
  GET(%InstancePrefix:LoadedTreeQueue,%InstancePrefix:LoadedTreeQueue.%InstancePrefix:Loaded%MainFieldID)
  %InstancePrefix:LoadedTreeQueue.%InstancePrefix:LoadedLevel = -1
  PUT(%InstancePrefix:LoadedTreeQueue)

  %InstancePrefix:CurrentLevel = ABS(%TreeQueue.%InstancePrefix:Level)
  %InstancePrefix:CurrentChoice += 1
  LOOP
    GET(%TreeQueue,%InstancePrefix:CurrentChoice)
    IF ERRORCODE() THEN BREAK.
    IF ABS(%TreeQueue.%InstancePrefix:Level) <= %InstancePrefix:CurrentLevel THEN BREAK.
    DELETE(%TreeQueue)
  END
  post(EVENT:NewSelection,%TreeControl)
  #EMBED(%SingleFileContractLevel,' ContractLevel'),%ActiveTemplateInstance,MAP(%ActiveTemplateInstance,%ActiveTemplateinstanceDescription)

!------------------------------------------------------
%InstancePrefix:ExpandLevel ROUTINE
  %InstancePrefix:CurrentChoice = %TreeControl{PropList:MouseDownRow}
  #IF(%TreeTitle)
  IF %InstancePrefix:CurrentChoice = 1 THEN EXIT.
  #ENDIF

  GET(%TreeQueue,%InstancePrefix:CurrentChoice)
  IF %TreeQueue.%InstancePrefix:Level > 0 THEN EXIT.

#IF(%CurrentDriverIsSQL)
  REGET(%ChildKey,%TreeQueue.%InstancePrefix:Position)
#ELSE
  REGET(%Primary,%TreeQueue.%InstancePrefix:Position)
#ENDIF
#FOR(%HotFields)
  #SET(%ValueConstruct,%HotField)
  #INSERT(%ConvertName,%ValueConstruct)
  %HotField = %TreeQueue.%InstancePrefix:%ValueConstruct
#ENDFOR

  %TreeQueue.%InstancePrefix:Loaded = 1
  %TreeQueue.%InstancePrefix:Level = ABS(%TreeQueue.%InstancePrefix:Level)
  #INSERT(%SetIconColorSingleFileTree,%TreeQueue)
  PUT(%TreeQueue)
  %InstancePrefix:LoadedTreeQueue.%InstancePrefix:Loaded%MainFieldID = %TreeQueue.%InstancePrefix:%MainFieldID
  GET(%InstancePrefix:LoadedTreeQueue,%InstancePrefix:LoadedTreeQueue.%InstancePrefix:Loaded%MainFieldID)
  %InstancePrefix:LoadedTreeQueue.%InstancePrefix:LoadedLevel = 1
  PUT(%InstancePrefix:LoadedTreeQueue)
  %RecursiveProcedureLoadLevel(%TreeQueue,%InstancePrefix:LoadedTreeQueue,%TreeQueue.%InstancePrefix:%MainFieldID,ABS(%TreeQueue.%InstancePrefix:Level),0)
  post(EVENT:NewSelection,%TreeControl)
  #EMBED(%SingleFileExpandLevel,' ExpandLevel'),%ActiveTemplateInstance,MAP(%ActiveTemplateInstance,%ActiveTemplateinstanceDescription)
!------------------------------------------------------
%InstancePrefix:NewSelection ROUTINE
#IF(%EnableMoveBranch)
  %InstancePrefix:OldChoice = %InstancePrefix:CurrentChoice
#ENDIF
  %InstancePrefix:CurrentChoice = CHOICE(%TreeControl)
  GET(%TreeQueue,%InstancePrefix:CurrentChoice)
#IF(%CurrentDriverIsSQL)
  REGET(%ChildKey,%TreeQueue.%InstancePrefix:Position)
#ELSE
  REGET(%Primary,%TreeQueue.%InstancePrefix:Position)
#ENDIF
#FOR(%HotFields)
  #SET(%ValueConstruct,%HotField)
  #INSERT(%ConvertName,%ValueConstruct)
  %HotField = %TreeQueue.%InstancePrefix:%ValueConstruct
#ENDFOR
  #EMBED(%SingleFileTreeNewSelection,' NewSelection'),%ActiveTemplateInstance,MAP(%ActiveTemplateInstance,%ActiveTemplateinstanceDescription),HIDE
  #EMBED(%SingleFileTreeNewSelectionBeforeMouseRight,'NewSelection ROUTINE:   MouseRight'),%ActiveTemplateInstance,MAP(%ActiveTemplateInstance,%ActiveTemplateinstanceDescription)
  IF KEYCODE() = MouseRight
    %InstancePrefix:CurrentChoice = CHOICE(%TreeControl)
    %InstancePrefix:PopupText = ''
    #EMBED(%SingleFileTreeSelectPopUp,' PopUp-()'),%ActiveTemplateInstance,MAP(%ActiveTemplateInstance,%ActiveTemplateinstanceDescription),HIDE
    #EMBED(%SingleFileTreeEditPopUp,' PopUp-()'),%ActiveTemplateInstance,MAP(%ActiveTemplateInstance,%ActiveTemplateinstanceDescription),HIDE
    #EMBED(%SingleFileTreeExpConPopUp,' PopUp-(/)'),%ActiveTemplateInstance,MAP(%ActiveTemplateInstance,%ActiveTemplateinstanceDescription),HIDE
    #EMBED(%SingleFileTreePopUp,' PopUp-'),%ActiveTemplateInstance,MAP(%ActiveTemplateInstance,%ActiveTemplateinstanceDescription)
    EXECUTE(POPUP(%InstancePrefix:PopupText))
      #EMBED(%SingleFileTreeSelectPopUpHandling,' PopUp-()'),%ActiveTemplateInstance,MAP(%ActiveTemplateInstance,%ActiveTemplateinstanceDescription),HIDE
      #EMBED(%SingleFileTreeEditPopUpHandling,' PopUp-()'),%ActiveTemplateInstance,MAP(%ActiveTemplateInstance,%ActiveTemplateinstanceDescription),HIDE
      #EMBED(%SingleFileTreeExpConPopUpHandling,' PopUp-(/)'),%ActiveTemplateInstance,MAP(%ActiveTemplateInstance,%ActiveTemplateinstanceDescription),HIDE
      #EMBED(%SingleFileTreeHandling,' PopUp-'),%ActiveTemplateInstance,MAP(%ActiveTemplateInstance,%ActiveTemplateinstanceDescription)
    END
  ELSE
    Display
  END
!------------------------------------------------------
%InstancePrefix:LoadBranch ROUTINE
  FREE(%BranchQueue)
  FREE(%InstancePrefix:LoadedBranchQueue)
  %BranchQueue = %TreeQueue
  ADD(%BranchQueue)
  %RecursiveProcedureLoadLevel(%BranchQueue,%InstancePrefix:LoadedBranchQueue,%TreeQueue.%InstancePrefix:%MainFieldID,ABS(%TreeQueue.%InstancePrefix:Level),1)
#ENDAT
#!-------------------------------------------------------------------------
#AT(%ProcedureRoutines),WHERE(%EnableMoveBranch)
!------------------------------------------------------
%InstancePrefix:MovingBranch ROUTINE
#FIX(%File,%Primary)
#FIX(%Field,%MainField)
#FIX(%Control,%TreeControl)
#IF(%TreeTitle)
  #SET(%ValueConstruct,1)
#ELSE
  #SET(%ValueConstruct,0)
#ENDIF
  %InstancePrefix:MoveBranch = 0
#IF(%TreeTitle)
  IF %InstancePrefix:OldChoice = %ValueConstruct THEN %InstancePrefix:MoveBranch = 1.
#ENDIF
  IF %InstancePrefix:OldChoice = %InstancePrefix:CurrentChoice THEN %InstancePrefix:MoveBranch = 1.

  GET(%TreeQueue,%InstancePrefix:OldChoice)
  %InstancePrefix:Save:%MainFieldID = %TreeQueue.%InstancePrefix:%MainFieldID
  GET(%TreeQueue,%InstancePrefix:CurrentChoice)

  LOOP WHILE abs(%TreeQueue.%InstancePrefix:Level) > %ValueConstruct
    %TreeQueue.%InstancePrefix:%MainFieldID = %TreeQueue.%InstancePrefix:%ChildFieldID
    GET(%TreeQueue,+%TreeQueue.%InstancePrefix:%MainFieldID)
    IF %TreeQueue.%InstancePrefix:%MainFieldID = %InstancePrefix:Save:%MainFieldID
      %InstancePrefix:MoveBranch = 1
      BREAK
    END
  END
  IF %InstancePrefix:MoveBranch = 1
    BEEP
    EXIT
  END

  GET(%TreeQueue,%InstancePrefix:CurrentChoice)
  %InstancePrefix:Save:%MainFieldID = %TreeQueue.%InstancePrefix:%MainFieldID

  GET(%TreeQueue,%InstancePrefix:OldChoice)
#IF(%CurrentDriverIsSQL)
  REGET(%ChildKey,%TreeQueue.%InstancePrefix:Position)
#ELSE
  REGET(%Primary,%TreeQueue.%InstancePrefix:Position)
#ENDIF
  %ChildField = %InstancePrefix:Save:%MainFieldID
  #EMBED(%MovingBranch,' '),%ActiveTemplateInstance,MAP(%ActiveTemplateInstance,%ActiveTemplateinstanceDescription)
  LOOP
    ThisWindow.Response = RequestCancelled
    SETCURSOR(Cursor:Wait)
    IF Relate:%Primary.Update()
      SETCURSOR()
     ! CASE StandardWarning(Warn:UpdateError)
     ! OF Button:Yes
     !   CYCLE
     ! OF Button:No
     !   BREAK
     ! OF Button:Cancel
     !   DISPLAY
     !   SELECT(%TreeControl)
     !   BREAK
     ! END
    ELSE
      ThisWindow.Response = RequestCompleted
    END
    BREAK
  END

  %InstancePrefix:LoadedTreeQueue.%InstancePrefix:Loaded%MainFieldID = %InstancePrefix:Save:%MainFieldID
  GET(%InstancePrefix:LoadedTreeQueue,%InstancePrefix:LoadedTreeQueue.%InstancePrefix:Loaded%MainFieldID)
  %InstancePrefix:LoadedTreeQueue.%InstancePrefix:LoadedLevel = 1
  PUT(%InstancePrefix:LoadedTreeQueue)

  DO %InstancePrefix:RefreshTree
  SETCURSOR()
#ENDAT
#!-------------------------------------------------------------------------
#AT(%LocalProcedures)
  #FIX(%File,%Primary)
  #FIX(%Field,%MainField)
  #FIX(%Key,%ChildKey)
  #FIX(%Control,%TreeControl)
!======================================================
  #SET(%ValueConstruct,%TestPresentSubLevelProcedure & ' FUNCTION(' &  %FieldType & ' ' & %MainFieldID & ')')
%ValueConstruct
PresentSubLevel LONG

  CODE
  PresentSubLevel = 0
  #EMBED(%TestPresentBeforeClearSingleFileTree,'Single File Tree (TestPresent)-  Clear  '),%ActiveTemplateInstance,MAP(%ActiveTemplateInstance,%ActiveTemplateinstanceDescription)
  CLEAR(%FilePrefix:RECORD)
  %ChildField = %MainFieldID
  #EMBED(%TestPresentBeforeSetSingleFileTree,'Single File Tree (TestPresent)-  SET(Key,Key)  '),%ActiveTemplateInstance,MAP(%ActiveTemplateInstance,%ActiveTemplateinstanceDescription)
  SET(%ChildKey,%ChildKey)
  LOOP
    #EMBED(%BeforeNextSingleFileTree,'Single File Tree -  NEXT  '),%ActiveTemplateInstance,MAP(%ActiveTemplateInstance,%ActiveTemplateinstanceDescription)
    NEXT(%Primary)
    IF ERRORCODE() THEN BREAK.
    #CASE(%FieldType)
    #OF('STRING')
    #OROF('CSTRING')
    #OROF('PSTRING')
      #SET(%ValueConstruct,1)
    #ELSE
      #SET(%ValueConstruct,0)
    #ENDCASE
    #IF(%ValueConstruct = 0 OR (%ValueConstruct = 1 AND ~%KeyNoCase))
    IF %ChildField <> %MainFieldID THEN BREAK.
    #ELSE
    IF UPPER(%ChildField) <> UPPER(%MainFieldID) THEN BREAK.
    #ENDIF
  #IF(%FilterTree)
    IF NOT (%FilterTree) THEN CYCLE.
  #ENDIF
    #EMBED(%AfterNextSingleFileTree,'Single File Tree -  NEXT  '),%ActiveTemplateInstance,MAP(%ActiveTemplateInstance,%ActiveTemplateinstanceDescription)
    PresentSubLevel = 1
    BREAK
  END
  RETURN(PresentSubLevel)
!======================================================
  #SET(%ValueConstruct,%RecursiveProcedureLoadLevel & ' PROCEDURE(' & %InstancePrefix & 'QueueTreeType QueueTree, ' & %InstancePrefix & 'LoadedTreeQueueType LoadedQueue, ' & %FieldType & ' ' & %MainFieldID & ', LONG CurrentLevel, BYTE NeedExpand)')
%ValueConstruct
SavePosition    STRING(2000)
Sav:Records     LIKE(%FilePrefix:RECORD)
PresentSubLevel LONG
#EMBED(%RecursiveProcedureDataSection,'Single File Tree -     '),%ActiveTemplateInstance,MAP(%ActiveTemplateInstance,%ActiveTemplateinstanceDescription),DATA          #! Embedded Source Code

  CODE
  CLEAR(%FilePrefix:RECORD)
  %ChildField = %MainFieldID
  #EMBED(%BeforeSetSingleFileTree,'Single File Tree -  SET(Key,Key)  '),%ActiveTemplateInstance,MAP(%ActiveTemplateInstance,%ActiveTemplateinstanceDescription)
  SET(%ChildKey,%ChildKey)
  #EMBED(%AfterSetSingleFileTree,'Single File Tree -  SET(Key,Key)  '),%ActiveTemplateInstance,MAP(%ActiveTemplateInstance,%ActiveTemplateinstanceDescription)
  LOOP
    #EMBED(%BeforeNextSingleFileTree,'Single File Tree -  NEXT  '),%ActiveTemplateInstance,MAP(%ActiveTemplateInstance,%ActiveTemplateinstanceDescription)
    NEXT(%Primary)
    IF ERRORCODE() THEN BREAK.
    #CASE(%FieldType)
    #OF('STRING')
    #OROF('CSTRING')
    #OROF('PSTRING')
      #SET(%ValueConstruct,1)
    #ELSE
      #SET(%ValueConstruct,0)
    #ENDCASE
    #IF(%ValueConstruct = 0 OR (%ValueConstruct = 1 AND ~%KeyNoCase))
    IF %ChildField <> %MainFieldID THEN BREAK.
    #ELSE
    IF UPPER(%ChildField) <> UPPER(%MainFieldID) THEN BREAK.
    #ENDIF
  #IF(%FilterTree)
    IF NOT (%FilterTree) THEN CYCLE.
  #ENDIF
    #EMBED(%AfterNextSingleFileTree,'Single File Tree -  NEXT  '),%ActiveTemplateInstance,MAP(%ActiveTemplateInstance,%ActiveTemplateinstanceDescription)
    SavePosition = POSITION(%ChildKey)

    #INSERT(%StandardFormula(ABC),'Format Single File Tree')
    #INSERT(%SingleFileTreeSecondaryLookups)
    #EMBED(%BeforeFormatDisplaySingleFileTree,'Single File Tree -     '),%ActiveTemplateInstance,MAP(%ActiveTemplateInstance,%ActiveTemplateinstanceDescription)
    QueueTree.%InstancePrefix:Display = %DisplayTree
    QueueTree.%InstancePrefix:%MainFieldID = %MainField
    QueueTree.%InstancePrefix:%ChildFieldID = %ChildField
  #IF(%CurrentDriverIsSQL)
    QueueTree.%InstancePrefix:Position = POSITION(%ChildKey)
  #ELSE
    QueueTree.%InstancePrefix:Position = POSITION(%Primary)
  #ENDIF
  #FOR(%HotFields)
    #SET(%ValueConstruct,%HotField)
    #INSERT(%ConvertName,%ValueConstruct)
    QueueTree.%InstancePrefix:%ValueConstruct = %HotField
  #ENDFOR

    Sav:Records = %FilePrefix:RECORD
    PresentSubLevel = %TestPresentSubLevelProcedure(QueueTree.%InstancePrefix:%MainFieldID)
    %FilePrefix:RECORD = Sav:Records

    IF PresentSubLevel
      QueueTree.%InstancePrefix:Level = -(CurrentLevel + 1)
    ELSE
      QueueTree.%InstancePrefix:Level = CurrentLevel + 1
    END

    IF NeedExpand
      QueueTree.%InstancePrefix:Level = CurrentLevel + 1
    ELSE
      LoadedQueue.%InstancePrefix:Loaded%MainFieldID = QueueTree.%InstancePrefix:%MainFieldID
      GET(LoadedQueue,LoadedQueue.%InstancePrefix:Loaded%MainFieldID)
      IF ~ERRORCODE()
        QueueTree.%InstancePrefix:Level = CHOOSE(LoadedQueue.%InstancePrefix:LoadedLevel > 0,ABS(QueueTree.%InstancePrefix:Level),-ABS(QueueTree.%InstancePrefix:Level))
      END
    END

    LoadedQueue.%InstancePrefix:Loaded%MainFieldID = QueueTree.%InstancePrefix:%MainFieldID
    GET(LoadedQueue,LoadedQueue.%InstancePrefix:Loaded%MainFieldID)
    IF ERRORCODE()
      LoadedQueue.%InstancePrefix:LoadedLevel = CHOOSE(QueueTree.%InstancePrefix:Level > 0,1,-1)
      ADD(LoadedQueue,LoadedQueue.%InstancePrefix:Loaded%MainFieldID)
    ELSE
      IF NeedExpand
        LoadedQueue.%InstancePrefix:LoadedLevel = CHOOSE(QueueTree.%InstancePrefix:Level > 0,1,-1)
        PUT(LoadedQueue)
      END
    END

    IF PresentSubLevel AND LoadedQueue.%InstancePrefix:LoadedLevel > 0
      QueueTree.%InstancePrefix:Loaded = 1
    ELSE
      QueueTree.%InstancePrefix:Loaded = 0
    END
    #SET(%ValueConstruct,'QueueTree')
    #INSERT(%SetIconColorSingleFileTree,%ValueConstruct)
    #EMBED(%BeforeAddingFileToQueueSingleFileTree,'Single File Tree -      '),%ActiveTemplateInstance,MAP(%ActiveTemplateInstance,%ActiveTemplateinstanceDescription)

    ADD(QueueTree,POINTER(QueueTree)+1)

    #EMBED(%AfterAddingFileToQueueSingleFileTree,'Single File Tree -      '),%ActiveTemplateInstance,MAP(%ActiveTemplateInstance,%ActiveTemplateinstanceDescription)
    IF NeedExpand
      %RecursiveProcedureLoadLevel(QueueTree,LoadedQueue,QueueTree.%InstancePrefix:%MainFieldID,ABS(QueueTree.%InstancePrefix:Level),1)
    ELSIF LoadedQueue.%InstancePrefix:LoadedLevel > 0
      %RecursiveProcedureLoadLevel(QueueTree,LoadedQueue,QueueTree.%InstancePrefix:%MainFieldID,ABS(QueueTree.%InstancePrefix:Level),0)
    END
    RESET(%ChildKey,SavePosition)
    PREVIOUS(%Primary)
  END
  #EMBED(%AfterLoopSingleFileTree,'Single File Tree -  Loop  '),%ActiveTemplateInstance,MAP(%ActiveTemplateInstance,%ActiveTemplateinstanceDescription)
#ENDAT
#!-------------------------------------------------------------------------
#GROUP(%SetIconColorSingleFileTree,%PrefixQueueTree)
#IF(%ControlHasColor)
  #IF(ITEMS(%ConditionalColors))
    #FOR(%ConditionalColors)
      #IF(INSTANCE(%ConditionalColors) = 1)
        #IF(%PrefixQueueTree = 'QueueTree')
IF %ColorConditionProc
        #ELSE
IF %ColorCondition
        #ENDIF
      #ELSE
        #IF(%PrefixQueueTree = 'QueueTree')
ELSIF %ColorConditionProc
        #ELSE
ELSIF %ColorCondition
        #ENDIF
      #ENDIF
  %PrefixQueueTree.%InstancePrefix:NormalFG = %ConditionalForegroundNormal
  %PrefixQueueTree.%InstancePrefix:NormalBG = %ConditionalBackgroundNormal
  %PrefixQueueTree.%InstancePrefix:SelectedFG = %ConditionalForegroundSelected
  %PrefixQueueTree.%InstancePrefix:SelectedBG = %ConditionalBackgroundSelected
    #ENDFOR
ELSE
  %PrefixQueueTree.%InstancePrefix:NormalFG = %DefaultForegroundNormal
  %PrefixQueueTree.%InstancePrefix:NormalBG = %DefaultBackgroundNormal
  %PrefixQueueTree.%InstancePrefix:SelectedFG = %DefaultForegroundSelected
  %PrefixQueueTree.%InstancePrefix:SelectedBG = %DefaultBackgroundSelected
END
  #ELSE
%PrefixQueueTree.%InstancePrefix:NormalFG = %DefaultForegroundNormal
%PrefixQueueTree.%InstancePrefix:NormalBG = %DefaultBackgroundNormal
%PrefixQueueTree.%InstancePrefix:SelectedFG = %DefaultForegroundSelected
%PrefixQueueTree.%InstancePrefix:SelectedBG = %DefaultBackgroundSelected
  #ENDIF
#ENDIF
#IF(%ControlHasIcon)
  #IF(ITEMS(%ConditionalIcons))
    #FOR(%ConditionalIcons)
      #IF(INSTANCE(%ConditionalIcons) = 1)
        #IF(%PrefixQueueTree = 'QueueTree')
IF %IconConditionProc
        #ELSE
IF %IconCondition
        #ENDIF
      #ELSE
        #IF(%PrefixQueueTree = 'QueueTree')
ELSIF %IconConditionProc
        #ELSE
ELSIF %IconCondition
        #ENDIF
      #ENDIF
      #FIX(%IconList,%ConditionalIcon)
      #IF(%IconList)
        #CASE(%IconListType)
        #OF('Variable')
  %PrefixQueueTree.%InstancePrefix:Icon = %IconList
        #ELSE
          #SET(%ValueConstruct,INSTANCE(%IconList))
  %PrefixQueueTree.%InstancePrefix:Icon = %ValueConstruct
        #ENDCASE
      #ELSE
  %PrefixQueueTree.%InstancePrefix:Icon = 0
      #ENDIF
    #ENDFOR
ELSE
    #FIX(%IconList,%DefaultIcon)
    #IF(%IconList)
      #CASE(%IconListType)
      #OF('Variable')
  %PrefixQueueTree.%InstancePrefix:Icon = %IconList
      #ELSE
        #SET(%ValueConstruct,INSTANCE(%IconList))
  %PrefixQueueTree.%InstancePrefix:Icon = %ValueConstruct
      #ENDCASE
    #ELSE
  %PrefixQueueTree.%InstancePrefix:Icon = 0
    #ENDIF
END
  #ELSE
    #FIX(%IconList,%DefaultIcon)
    #IF(%IconList)
      #CASE(%IconListType)
      #OF('Variable')
%PrefixQueueTree.%InstancePrefix:Icon = %IconList
      #ELSE
        #SET(%ValueConstruct,INSTANCE(%IconList))
%PrefixQueueTree.%InstancePrefix:Icon = %ValueConstruct
      #ENDCASE
    #ELSE
%PrefixQueueTree.%InstancePrefix:Icon = 0
    #ENDIF
  #ENDIF
#ENDIF
#!-------------------------------------------------------------------------
#GROUP(%SingleFileTreeSecondaryLookups)
#FOR(%Secondary),WHERE(%SecondaryTo = %Primary)
  #FIX(%File,%Secondary)
  #FIX(%Relation,%Primary)
  #IF(%FileRelationType = '1:MANY')
    #FOR(%RelationKeyField),WHERE(%RelationKeyFieldLink AND %RelationKeyField)
%RelationKeyFieldLink = %RelationKeyField  #<!   
    #ENDFOR
GET(%File,%FileKey)                  #<!   
IF ERRORCODE()
  CLEAR(%FilePrefix:Record)          #<! ,  
    #FOR(%Field),WHERE(%FieldType='MEMO')
  CLEAR(%Field)
    #ENDFOR
END
  #ENDIF
#ENDFOR
#!---------------------------------------------------------------------------
#GROUP(%SingleFileTreeCommonDeclarations)
#DECLARE(%InstancePrefix)
#DECLARE(%TreeQueue)
#DECLARE(%TreeControl)
#DECLARE(%ChildField)
#DECLARE(%ChildFieldID)
#DECLARE(%MainFieldID)
#DECLARE(%TestPresentSubLevelProcedure)
#DECLARE(%RecursiveProcedureLoadLevel)
#FOR(%Control),WHERE(%ControlInstance = %ActiveTemplateInstance)
  #SET(%TreeControl,%Control)
  #SET(%TreeQueue,EXTRACT(%ControlStatement,'FROM',1))
#ENDFOR
#!  *** KreatoR *** 
#IF(%MyInstancePrefix)
  #SET(%InstancePrefix,%MyInstancePrefix)
#ELSE
  #SET(%InstancePrefix,'TSF' & %ActiveTemplateInstance)
#ENDIF
#FIX(%File,%Primary)
#FIX(%Field,%MainField)
#SET(%MainFieldID,%FieldID)
#FIX(%Key,%ChildKey)
#SELECT(%KeyField,1)
#SET(%ChildField,%KeyField)
#FIX(%Field,%ChildField)
#SET(%ChildFieldID,%FieldID)
#SET(%RecursiveProcedureLoadLevel,%InstancePrefix & ':LoadLevel')
#SET(%TestPresentSubLevelProcedure,%InstancePrefix & ':TestPresentSubLevel')
#!---------------------------------------------------------------------------
#GROUP(%SingleFileTreeDefType)
#FIX(%File,%Primary)
#FIX(%Field,%MainField)
#CASE(%FieldType)
#OF('STRING')
#OROF('CSTRING')
#OROF('PSTRING')
  #SET(%ValueConstruct,'''''')
#ELSE
  #SET(%ValueConstruct,0)
#ENDCASE
#!---------------------------------------------------------------------------
#CONTROL(SingleFileTreeExpandContractButtons,' /    '),DESCRIPTION(' /     ' & %Primary),REQ(SingleFileTree)
  CONTROLS
    BUTTON('& '),AT(,,65,14),USE(?ExpandAll)
    BUTTON('& '),AT(70,0,60,14),USE(?ContractAll)
  END
#BOXED('  /')
  #PROMPT(' ""   / ',CHECK),%WaitCursorExpandContract,AT(10)
  #PROMPT('&   Popup-',CHECK),%ExpConViaPopup,DEFAULT(1),AT(10,,150)
  #ENABLE(%ExpConViaPopup)
    #BUTTON('  Popup-'),AT(,,180,12)
      #BOXED('')
        #PROMPT('  Popup-:',DROP('  || ')),%TypeAddPopupIconExp,DEFAULT('  '),PROMPTAT(,,110),AT(,,70)
        #ENABLE(%TypeAddPopupIconExp = ''),CLEAR
          #PROMPT(':',@S40),%OtherPopupIconExp,REQ
        #ENDENABLE
      #ENDBOXED
      #BOXED('')
        #PROMPT('  Popup-:',DROP('  || ')),%TypeAddPopupIconCon,DEFAULT('  '),PROMPTAT(,,110),AT(,,70)
        #ENABLE(%TypeAddPopupIconCon = ''),CLEAR
          #PROMPT(':',@S40),%OtherPopupIconCon
        #ENDENABLE
      #ENDBOXED
    #ENDBUTTON
  #ENDENABLE
#ENDBOXED
#ATSTART
  #FIX(%File,%Primary)
  #FIX(%Field,%MainField)
  #DECLARE(%ExpandControl)
  #DECLARE(%ContractControl)
  #DECLARE(%ExpandPopupText)
  #DECLARE(%ContractPopupText)
  #FOR(%Control),WHERE(%ControlInstance = %ActiveTemplateInstance)
    #CASE(%ControlOriginal)
    #OF('?ExpandAll')
      #SET(%ExpandControl,%Control)
      #SET(%ValueConstruct,EXTRACT(%ControlStatement,'BUTTON',1))
      #SET(%ExpandPopupText,SUB(%ValueConstruct,2,LEN(%ValueConstruct)-2))
    #OF('?ContractAll')
      #SET(%ContractControl,%Control)
      #SET(%ValueConstruct,EXTRACT(%ControlStatement,'BUTTON',1))
      #SET(%ContractPopupText,SUB(%ValueConstruct,2,LEN(%ValueConstruct)-2))
    #ENDCASE
  #ENDFOR
#ENDAT
#AT(%ControlEventHandling,%ExpandControl,'Accepted')
DO %InstancePrefix:ExpandAll
SELECT(%TreeControl)
#ENDAT
#AT(%ControlEventHandling,%ContractControl,'Accepted')
DO %InstancePrefix:ContractAll
SELECT(%TreeControl)
#ENDAT
#AT(%SingleFileTreeExpConPopUp)
  #IF(%ExpConViaPopup)
    #IF(%Control=%TreeControl)
      #IF(%TreeTitle)
        #SET(%ValueConstruct,1)
      #ELSE
        #SET(%ValueConstruct,0)
      #ENDIF
IF %InstancePrefix:PopupText THEN %InstancePrefix:PopupText = CLIP(%InstancePrefix:PopupText) & '|-|'.
IF RECORDS(%TreeQueue) > %ValueConstruct
      #IF(%ExpandControl)
        #INSERT(%AddIconToPopup,%ExpandControl,%TreeControl,%OtherPopupIconExp,%TypeAddPopupIconExp)
  IF ~%ExpandControl{PROP:Disable}
    %InstancePrefix:PopupText = CLIP(%InstancePrefix:PopupText) & %ValueConstruct & '%'ExpandPopupText'
  ELSE
    %InstancePrefix:PopupText = CLIP(%InstancePrefix:PopupText) & '~' & %ValueConstruct & '%'ExpandPopupText'
  END
      #ENDIF
      #IF(%ContractControl)
        #INSERT(%AddIconToPopup,%ContractControl,%TreeControl,%OtherPopupIconCon,%TypeAddPopupIconCon)
  IF ~%ContractControl{PROP:Disable}
    %InstancePrefix:PopupText = CLIP(%InstancePrefix:PopupText) & '|' & %ValueConstruct & '%'ContractPopupText'
  ELSE
    %InstancePrefix:PopupText = CLIP(%InstancePrefix:PopupText) & '|~' & %ValueConstruct & '%'ContractPopupText'
  END
      #ENDIF
ELSE
      #IF(%ExpandControl)
        #INSERT(%AddIconToPopup,%ExpandControl,%TreeControl,%OtherPopupIconExp,%TypeAddPopupIconExp)
  %InstancePrefix:PopupText = CLIP(%InstancePrefix:PopupText) & '~' & %ValueConstruct & '%'ExpandPopupText'
      #ENDIF
      #IF(%ContractControl)
        #INSERT(%AddIconToPopup,%ContractControl,%TreeControl,%OtherPopupIconCon,%TypeAddPopupIconCon)
  %InstancePrefix:PopupText = CLIP(%InstancePrefix:PopupText) & '|~' & %ValueConstruct & '%'ContractPopupText'
      #ENDIF
END
    #ENDIF
  #ENDIF
#ENDAT
#AT(%SingleFileTreeExpConPopUpHandling)
  #IF(%ExpConViaPopup)
    #IF(%Control=%TreeControl)
      #IF(%ExpandControl)
IF ~%ExpandControl{PROP:Disable}
  DO %InstancePrefix:ExpandAll
END
      #ENDIF
      #IF(%ContractControl)
IF ~%ContractControl{PROP:Disable}
  DO %InstancePrefix:ContractAll
END
      #ENDIF
    #ENDIF
  #ENDIF
#ENDAT
#AT(%RefreshWindowBeforeDisplay)
  #IF(%TreeTitle)
    #SET(%ValueConstruct,1)
  #ELSE
    #SET(%ValueConstruct,0)
  #ENDIF
IF RECORDS(%TreeQueue) = %ValueConstruct
  #IF(%ExpandControl)
  %ExpandControl{PROP:Disable} = 1
  #ENDIF
  #IF(%ContractControl)
  %ContractControl{PROP:Disable} = 1
  #ENDIF
ELSE
  #IF(%ExpandControl)
  %ExpandControl{PROP:Disable} = 0
  #ENDIF
  #IF(%ContractControl)
  %ContractControl{PROP:Disable} = 0
  #ENDIF
END
#ENDAT
#AT(%BeforeExpConSingleFileTree)
  #IF(%WaitCursorExpandContract)
SETCURSOR(CURSOR:Wait)
  #ENDIF
#ENDAT
#AT(%AfterExpConSingleFileTree)
  #IF(%WaitCursorExpandContract)
SETCURSOR()
  #ENDIF
#ENDAT
#!---------------------------------------------------------------------------
#CONTROL(SingleFileTreeUpdateButtons,'     '),DESCRIPTION('     ' & %Primary),REQ(SingleFileTree)
  CONTROLS
    BUTTON('&'),AT(,,45,14),USE(?Insert)
    BUTTON('&'),AT(50,0,45,14),USE(?Change)
    BUTTON('&'),AT(50,0,45,14),USE(?Delete)
  END
#BOXED('  ')
  #PROMPT('&   ()',CHECK),%MultiUpdateProcedures,DEFAULT(0),AT(10,,150)
  #ENABLE(~%MultiUpdateProcedures)
    #PROMPT('& ',PROCEDURE),%UpdateProcedure
  #ENDENABLE
  #ENABLE(%MultiUpdateProcedures)
    #PROMPT('&   () ',EMBEDBUTTON(%SingleTreeUpdateProcedures)),AT(10,,180,12)
  #ENDENABLE
  #PROMPT(' &  ',CHECK),%EnableDeleteBranch,DEFAULT(0),AT(10,,150)
  #PROMPT('&   Popup-',CHECK),%EditViaPopup,DEFAULT(1),AT(10,,150)
  #ENABLE(%EditViaPopup)
    #BUTTON('  Popup-'),AT(,,180,12)
      #BOXED('')
        #PROMPT('  Popup-:',DROP('  || ')),%TypeAddPopupIconInsert,DEFAULT('  '),PROMPTAT(,,110),AT(,,70)
        #ENABLE(%TypeAddPopupIconInsert = ''),CLEAR
          #PROMPT(':',@S40),%OtherPopupIconInsert,REQ
        #ENDENABLE
      #ENDBOXED
      #BOXED('')
        #PROMPT('  Popup-:',DROP('  || ')),%TypeAddPopupIconChange,DEFAULT('  '),PROMPTAT(,,110),AT(,,70)
        #ENABLE(%TypeAddPopupIconChange = ''),CLEAR
          #PROMPT(':',@S40),%OtherPopupIconChange
        #ENDENABLE
      #ENDBOXED
      #BOXED('')
        #PROMPT('  Popup-:',DROP('  || ')),%TypeAddPopupIconDelete,DEFAULT('  '),PROMPTAT(,,110),AT(,,70)
        #ENABLE(%TypeAddPopupIconDelete = ''),CLEAR
          #PROMPT(':',@S40),%OtherPopupIconDelete
        #ENDENABLE
      #ENDBOXED
    #ENDBUTTON
  #ENDENABLE
#ENDBOXED
#ATSTART
  #FIX(%File,%Primary)
  #FIX(%Field,%MainField)
  #DECLARE(%AddControl)
  #DECLARE(%EditControl)
  #DECLARE(%RemoveControl)
  #DECLARE(%InsertPopupText)
  #DECLARE(%ChangePopupText)
  #DECLARE(%DeletePopupText)
  #FOR(%Control),WHERE(%ControlInstance = %ActiveTemplateInstance)
    #CASE(%ControlOriginal)
    #OF('?Insert')
    #OROF('?Add')
      #SET(%AddControl,%Control)
      #SET(%ValueConstruct,EXTRACT(%ControlStatement,'BUTTON',1))
      #SET(%InsertPopupText,SUB(%ValueConstruct,2,LEN(%ValueConstruct)-2))
    #OF('?Change')
    #OROF('?Edit')
      #SET(%EditControl,%Control)
      #SET(%ValueConstruct,EXTRACT(%ControlStatement,'BUTTON',1))
      #SET(%ChangePopupText,SUB(%ValueConstruct,2,LEN(%ValueConstruct)-2))
    #OF('?Delete')
    #OROF('?Remove')
      #SET(%RemoveControl,%Control)
      #SET(%ValueConstruct,EXTRACT(%ControlStatement,'BUTTON',1))
      #SET(%DeletePopupText,SUB(%ValueConstruct,2,LEN(%ValueConstruct)-2))
    #ENDCASE
  #ENDFOR
#ENDAT
#AT(%ControlEventHandling,%AddControl,'Accepted')
GlobalRequest = InsertRecord
DO %InstancePrefix:EditServer
#ENDAT
#AT(%ControlEventHandling,%RemoveControl,'Accepted')
GlobalRequest = DeleteRecord
DO %InstancePrefix:EditServer
#ENDAT
#AT(%ControlEventHandling,%EditControl,'Accepted')
GlobalRequest = ChangeRecord
DO %InstancePrefix:EditServer
#ENDAT
#AT(%PrepareAlerts)
#IF(%EditControl)
%TreeControl{Prop:Alrt,253} = MouseLeft2
#ENDIF
#IF(%AddControl)
%TreeControl{Prop:Alrt,252} = InsertKey
#ENDIF
#IF(%RemoveControl)
%TreeControl{Prop:Alrt,251} = DeleteKey
#ENDIF
#IF(%EditControl)
%TreeControl{Prop:Alrt,250} = CtrlEnter
#ENDIF
#ENDAT
#AT(%AlertKeySingleFileTreeDoubleClick)
#IF(%EditControl)
  #IF(%Control=%TreeControl)
IF ~%EditControl{PROP:Disable}
  POST(Event:Accepted,%EditControl)
END
  #ENDIF
#ENDIF
#ENDAT
#AT(%AlertKeySingleFileTree)
#IF(%EditControl)
OF CtrlEnter
  IF ~%EditControl{PROP:Disable}
    POST(Event:Accepted,%EditControl)
  END
#ENDIF
#IF(%AddControl)
OF InsertKey
  IF ~%AddControl{PROP:Disable}
    POST(Event:Accepted,%AddControl)
  END
#ENDIF
#IF(%RemoveControl)
OF DeleteKey
  IF ~%RemoveControl{PROP:Disable}
    POST(Event:Accepted,%RemoveControl)
  END
#ENDIF
#ENDAT
#AT(%RefreshWindowBeforeDisplay)
  #IF(%TreeTitle)
    #SET(%ValueConstruct,1)
  #ELSE
    #SET(%ValueConstruct,0)
  #ENDIF
IF RECORDS(%TreeQueue) = %ValueConstruct
  #IF(%EditControl)
  %EditControl{PROP:Disable} = 1
  #ENDIF
  #IF(%RemoveControl)
  %RemoveControl{PROP:Disable} = 1
  #ENDIF
ELSE
  #IF(%EditControl)
  %EditControl{PROP:Disable} = 0
  #ENDIF
  #IF(%RemoveControl)
  %RemoveControl{PROP:Disable} = 0
  #ENDIF
END
  #IF(%TreeTitle)
IF %InstancePrefix:CurrentChoice = 1
    #IF(%EditControl)
  %EditControl{PROP:Disable} = 1
    #ENDIF
    #IF(%RemoveControl)
  %RemoveControl{PROP:Disable} = 1
    #ENDIF
END
  #ENDIF
#ENDAT
#AT(%SingleFileTreeNewSelection)
  #IF(%Control=%TreeControl)
    #IF(%TreeTitle)
IF %InstancePrefix:CurrentChoice = 1
    #IF(%EditControl)
  %EditControl{PROP:Disable} = 1
    #ENDIF
    #IF(%RemoveControl)
  %RemoveControl{PROP:Disable} = 1
    #ENDIF
ELSE
    #IF(%EditControl)
  %EditControl{PROP:Disable} = 0
    #ENDIF
    #IF(%RemoveControl)
  %RemoveControl{PROP:Disable} = 0
    #ENDIF
END
    #ENDIF
  #ENDIF
#ENDAT
#AT(%ProcedureRoutines)
#FIX(%File,%Primary)
#FIX(%Field,%MainField)
#FIX(%Control,%TreeControl)
!------------------------------------------------------
%InstancePrefix:EditServer ROUTINE
  #IF(%TreeTitle)
    #SET(%ValueConstruct,1)
  #ELSE
    #SET(%ValueConstruct,0)
  #ENDIF
  #EMBED(%BeginEntryRoutineSingleFileTree,'EditServer ROUTINE - '),%ActiveTemplateInstance,MAP(%ActiveTemplateInstance,%ActiveTemplateinstanceDescription)
  %InstancePrefix:CurrentChoice = CHOICE(%TreeControl)
  IF %InstancePrefix:CurrentChoice = %ValueConstruct AND GlobalRequest <> InsertRecord THEN EXIT.
  GET(%TreeQueue,%InstancePrefix:CurrentChoice)
  CASE GlobalRequest
  #IF(%AddControl)
  OF InsertRecord
    #EMBED(%BeforePreparingRecordOnAddSingleFileTree,'EditServer ROUTINE -     '),%ActiveTemplateInstance,MAP(%ActiveTemplateInstance,%ActiveTemplateinstanceDescription)
    GET(%Primary,0)
    CLEAR(%FilePrefix:RECORD)
    #FOR(%Field),WHERE(%FieldType = 'MEMO')
    CLEAR(%Field)
    #ENDFOR
    #FIX(%Field,%MainField)
    %ChildField = %TreeQueue.%InstancePrefix:%MainFieldID
    #EMBED(%BeforeCallingUpdateOnAddSingleFileTree,'EditServer ROUTINE -      '),%ActiveTemplateInstance,MAP(%ActiveTemplateInstance,%ActiveTemplateinstanceDescription)
    #IF(%MultiUpdateProcedures)
    #EMBED(%SingleTreeUpdateProcedures,'CallUpdate ROUTINE -  () '),%ActiveTemplateInstance,MAP(%ActiveTemplateInstance,%ActivetemplateInstanceDescription),WHERE(%MultiUpdateProcedures)
    #ELSE
    %UpdateProcedure
    #ENDIF
    IF GlobalResponse = RequestCompleted
      %InstancePrefix:Save:%MainFieldID = %MainField
      IF ABS(%TreeQueue.%InstancePrefix:Level)
        %InstancePrefix:LoadedTreeQueue.%InstancePrefix:Loaded%MainFieldID = %TreeQueue.%InstancePrefix:%MainFieldID
        GET(%InstancePrefix:LoadedTreeQueue,%InstancePrefix:LoadedTreeQueue.%InstancePrefix:Loaded%MainFieldID)
        %InstancePrefix:LoadedTreeQueue.%InstancePrefix:LoadedLevel = 1
        PUT(%InstancePrefix:LoadedTreeQueue)
      END
      DO %InstancePrefix:RefreshTree
      LOOP
        %InstancePrefix:CurrentChoice += 1
        GET(%TreeQueue,%InstancePrefix:CurrentChoice)
        IF ERRORCODE() THEN BREAK.
        IF %InstancePrefix:Save:%MainFieldID = %TreeQueue.%InstancePrefix:%MainFieldID THEN BREAK.
      END
      SELECT(%TreeControl,%InstancePrefix:CurrentChoice)
    END
    #EMBED(%AfterCallingUpdateOnAddSingleFileTree,'EditServer ROUTINE -      '),%ActiveTemplateInstance,MAP(%ActiveTemplateInstance,%ActiveTemplateinstanceDescription)
  #ENDIF
  #IF(%EditControl)
  OF ChangeRecord
    #IF(%CurrentDriverIsSQL)
    REGET(%ChildKey,%TreeQueue.%InstancePrefix:Position)
    #ELSE
    REGET(%Primary,%TreeQueue.%InstancePrefix:Position)
    #ENDIF
    #EMBED(%BeforeCallingUpdateOnEditSingleFileTree,'EditServer ROUTINE -      '),%ActiveTemplateInstance,MAP(%ActiveTemplateInstance,%ActiveTemplateinstanceDescription)
    #IF(%MultiUpdateProcedures)
    #EMBED(%SingleTreeUpdateProcedures,'CallUpdate ROUTINE -  () '),%ActiveTemplateInstance,MAP(%ActiveTemplateInstance,%ActivetemplateInstanceDescription),WHERE(%MultiUpdateProcedures)
    #ELSE
    %UpdateProcedure
    #ENDIF
    IF GlobalResponse = RequestCompleted
      DO %InstancePrefix:RefreshTree
    END
    #EMBED(%AfterCallingUpdateOnEditSingleFileTree,'EditServer ROUTINE -      '),%ActiveTemplateInstance,MAP(%ActiveTemplateInstance,%ActiveTemplateinstanceDescription)
  #ENDIF
  #IF(%RemoveControl)
  OF DeleteRecord
      %InstancePrefix:PresentSubLevel = %TestPresentSubLevelProcedure(%TreeQueue.%InstancePrefix:%MainFieldID)                 ! *** KreatoR ***
      #EMBED(%SingleTreeDeleteProcedures,'CallDelete ROUTINE -  () '),%ActiveTemplateInstance,MAP(%ActiveTemplateInstance,%ActivetemplateInstanceDescription),WHERE(%MultiUpdateProcedures)
#!    if %TreeQueue.%InstancePrefix:Level < 0
#!      %InstancePrefix:PresentSubLevel = 1
#!    else
#!      %InstancePrefix:PresentSubLevel = 0
#!    end
    IF %InstancePrefix:PresentSubLevel = 0
    #IF(%CurrentDriverIsSQL)
      REGET(%ChildKey,%TreeQueue.%InstancePrefix:Position)
    #ELSE
      REGET(%Primary,%TreeQueue.%InstancePrefix:Position)
    #ENDIF
      #EMBED(%BeforeCallingUpdateOnRemoveSingleFileTree,'EditServer ROUTINE -      '),%ActiveTemplateInstance,MAP(%ActiveTemplateInstance,%ActiveTemplateinstanceDescription)
    #IF(%MultiUpdateProcedures)
      #EMBED(%SingleTreeUpdateProcedures,'CallUpdate ROUTINE -  () '),%ActiveTemplateInstance,MAP(%ActiveTemplateInstance,%ActivetemplateInstanceDescription),WHERE(%MultiUpdateProcedures)
    #ELSE
      %UpdateProcedure
    #ENDIF
      IF GlobalResponse = RequestCompleted
        %InstancePrefix:LoadedTreeQueue.%InstancePrefix:Loaded%MainFieldID = %TreeQueue.%InstancePrefix:%MainFieldID
        GET(%InstancePrefix:LoadedTreeQueue,%InstancePrefix:LoadedTreeQueue.%InstancePrefix:Loaded%MainFieldID)
        DELETE(%InstancePrefix:LoadedTreeQueue)
        DO %InstancePrefix:RefreshTree
      END
      #EMBED(%AfterCallingUpdateOnRemoveSingleFileTree,'EditServer ROUTINE -      '),%ActiveTemplateInstance,MAP(%ActiveTemplateInstance,%ActiveTemplateinstanceDescription)
    ELSE
    #IF(%EnableDeleteBranch)
      DO %InstancePrefix:DeleteBranch
      DO %InstancePrefix:RefreshTree
    #ELSE
      MESSAGE('     ().| !','!',ICON:Exclamation,BUTTON:CANCEL)
    #ENDIF
    END
  #ENDIF
  END
  !DO SyncWindow
  Display
  #EMBED(%BeforeRefreshWindowOnEditSingleFileTree,'EditServer ROUTINE -   RefreshWindow'),%ActiveTemplateInstance,MAP(%ActiveTemplateInstance,%ActiveTemplateinstanceDescription)
  Display
  #EMBED(%AfterRefreshWindowOnEditSingleFileTree,'EditServer ROUTINE -   RefreshWindow'),%ActiveTemplateInstance,MAP(%ActiveTemplateInstance,%ActiveTemplateinstanceDescription)
  SELECT(%TreeControl)
  #IF(%EnableDeleteBranch)
!------------------------------------------------------
%InstancePrefix:DeleteBranch ROUTINE
  IF MESSAGE('    .|'|
    &'    .|   .|'|
    &'  OK   |'|
    &'    .',|
    ' ',Icon:Question,Button:OK+Button:Cancel,Button:Cancel,0) = Button:Cancel THEN EXIT.
    #DECLARE(%LogoutDesired)
    #DECLARE(%LogoutParameters)
    #DECLARE(%RegetParameter)
    #SET(%LogoutDesired,%False)
    #IF(%OverrideRILogout = 'Use Default' OR %OverrideRILogout = '' OR NOT %OverrideRILogout)
      #IF(%DefaultRILogout)
        #SET(%LogoutDesired,%True)
      #ENDIF
    #ELSIF(%OverrideRILogout = 'Yes' OR %OverrideRILogout = '')
      #SET(%LogoutDesired,%True)
    #ENDIF
    #IF(%LogoutDesired)
      #FIX(%Driver,%FileDriver)
      #FIX(%DriverOpCode,'LOGOUT')
      #IF(%DriverOpCode)
        #IF(%AliasFile)
          #SET(%LogoutParameters,%LockRecoverTime& ',' & %AliasFile)
        #ELSE
          #SET(%LogoutParameters,%LockRecoverTime& ',' & %File)
        #ENDIF
      #ELSE
        #SET(%LogoutDesired,%False)
      #ENDIF
    #ENDIF
    #SET(%RegetParameter,%Null)
    #FOR(%Key),WHERE(EXTRACT(%KeyStruct,'PRIMARY'))
      #SET(%RegetParameter,%Key)
    #ENDFOR
    #IF(NOT(%RegetParameter))
      #FOR(%Key)
        #SET(%RegetParameter,%Key)
        #BREAK
      #ENDFOR
    #ENDIF
    #IF(NOT(%RegetParameter))
      #SET(%RegetParameter,%File)
    #ENDIF
  DO %InstancePrefix:LoadBranch
    #IF(%LogoutDesired)
  LOGOUT(%LogoutParameters)
  IF ERRORCODE()
    !RISaveError
    !StandardWarning(Warn:LogoutError,'Delete','%Primary')
    EXIT
  END
    #ENDIF
  %InstancePrefix:CurrentChoice = 1
  LOOP
    GET(%BranchQueue,%InstancePrefix:CurrentChoice)
    IF ERRORCODE() THEN BREAK.
    #IF(%CurrentDriverIsSQL)
    REGET(%ChildKey,%BranchQueue.%InstancePrefix:Position)
    #ELSE
    REGET(%Primary,%BranchQueue.%InstancePrefix:Position)
    #ENDIF
    DELETE(%Primary)
    IF ERRORCODE()
      !RISaveError
      !StandardWarning(Warn:RIDeleteError,'%Primary')
    #IF(%LogoutDesired)
      ROLLBACK
    #ENDIF
      EXIT
    END
    %InstancePrefix:LoadedTreeQueue.%InstancePrefix:Loaded%MainFieldID = %BranchQueue.%InstancePrefix:%MainFieldID
    GET(%InstancePrefix:LoadedTreeQueue,%InstancePrefix:LoadedTreeQueue.%InstancePrefix:Loaded%MainFieldID)
    DELETE(%InstancePrefix:LoadedTreeQueue)
    %InstancePrefix:CurrentChoice += 1
  END
    #IF(%LogoutDesired)
  COMMIT
    #ENDIF
  #ENDIF
#ENDAT
#AT(%SingleFileTreeEditPopUp)
  #IF(%EditViaPopup)
    #IF(%Control=%TreeControl)
      #IF(%TreeTitle)
        #SET(%ValueConstruct,1)
      #ELSE
        #SET(%ValueConstruct,0)
      #ENDIF
IF %InstancePrefix:PopupText THEN %InstancePrefix:PopupText = CLIP(%InstancePrefix:PopupText) & '|-|'.
IF RECORDS(%TreeQueue) > %ValueConstruct
      #IF(%ValueConstruct = 1)
  IF %InstancePrefix:CurrentChoice = 1
        #IF(%AddControl)
          #INSERT(%AddIconToPopup,%AddControl,%TreeControl,%OtherPopupIconInsert,%TypeAddPopupIconInsert)
    IF ~%AddControl{PROP:Disable}
      %InstancePrefix:PopupText = CLIP(%InstancePrefix:PopupText) & %ValueConstruct & '%'InsertPopupText'
    ELSE
      %InstancePrefix:PopupText = CLIP(%InstancePrefix:PopupText) & '~' & %ValueConstruct & '%'InsertPopupText'
    END
        #ENDIF
        #IF(%EditControl)
          #INSERT(%AddIconToPopup,%EditControl,%TreeControl,%OtherPopupIconChange,%TypeAddPopupIconChange)
    %InstancePrefix:PopupText = CLIP(%InstancePrefix:PopupText) & '|~' & %ValueConstruct & '%'ChangePopupText'
        #ENDIF
        #IF(%RemoveControl)
          #INSERT(%AddIconToPopup,%RemoveControl,%TreeControl,%OtherPopupIconDelete,%TypeAddPopupIconDelete)
    %InstancePrefix:PopupText = CLIP(%InstancePrefix:PopupText) & '|~' & %ValueConstruct & '%'DeletePopupText'
        #ENDIF
  ELSE
        #IF(%AddControl)
          #INSERT(%AddIconToPopup,%AddControl,%TreeControl,%OtherPopupIconInsert,%TypeAddPopupIconInsert)
    IF ~%AddControl{PROP:Disable}
      %InstancePrefix:PopupText = CLIP(%InstancePrefix:PopupText) & %ValueConstruct & '%'InsertPopupText'
    ELSE
      %InstancePrefix:PopupText = CLIP(%InstancePrefix:PopupText) & '~' & %ValueConstruct & '%'InsertPopupText'
    END
        #ENDIF
        #IF(%EditControl)
          #INSERT(%AddIconToPopup,%EditControl,%TreeControl,%OtherPopupIconChange,%TypeAddPopupIconChange)
    IF ~%EditControl{PROP:Disable}
      %InstancePrefix:PopupText = CLIP(%InstancePrefix:PopupText) & '|' & %ValueConstruct & '%'ChangePopupText'
    ELSE
      %InstancePrefix:PopupText = CLIP(%InstancePrefix:PopupText) & '|~' & %ValueConstruct & '%'ChangePopupText'
    END
        #ENDIF
        #IF(%RemoveControl)
          #INSERT(%AddIconToPopup,%RemoveControl,%TreeControl,%OtherPopupIconDelete,%TypeAddPopupIconDelete)
    IF ~%RemoveControl{PROP:Disable}
      %InstancePrefix:PopupText = CLIP(%InstancePrefix:PopupText) & '|' & %ValueConstruct & '%'DeletePopupText'
    ELSE
      %InstancePrefix:PopupText = CLIP(%InstancePrefix:PopupText) & '|~' & %ValueConstruct & '%'DeletePopupText'
    END
        #ENDIF
  END
      #ELSE
        #IF(%AddControl)
          #INSERT(%AddIconToPopup,%AddControl,%TreeControl,%OtherPopupIconInsert,%TypeAddPopupIconInsert)
  IF ~%AddControl{PROP:Disable}
    %InstancePrefix:PopupText = CLIP(%InstancePrefix:PopupText) & %ValueConstruct & '%'InsertPopupText'
  ELSE
    %InstancePrefix:PopupText = CLIP(%InstancePrefix:PopupText) & '~' & %ValueConstruct & '%'InsertPopupText'
  END
        #ENDIF
        #IF(%EditControl)
          #INSERT(%AddIconToPopup,%EditControl,%TreeControl,%OtherPopupIconChange,%TypeAddPopupIconChange)
  %InstancePrefix:PopupText = CLIP(%InstancePrefix:PopupText) & '|~' & %ValueConstruct & '%'ChangePopupText'
        #ENDIF
        #IF(%RemoveControl)
          #INSERT(%AddIconToPopup,%RemoveControl,%TreeControl,%OtherPopupIconChange,%TypeAddPopupIconDelete)
  %InstancePrefix:PopupText = CLIP(%InstancePrefix:PopupText) & '|~' & %ValueConstruct & '%'DeletePopupText'
        #ENDIF
      #ENDIF
ELSE
      #IF(%AddControl)
        #INSERT(%AddIconToPopup,%AddControl,%TreeControl,%OtherPopupIconInsert,%TypeAddPopupIconInsert)
  IF ~%AddControl{PROP:Disable}
    %InstancePrefix:PopupText = CLIP(%InstancePrefix:PopupText) & %ValueConstruct & '%'InsertPopupText'
  ELSE
    %InstancePrefix:PopupText = CLIP(%InstancePrefix:PopupText) & '~' & %ValueConstruct & '%'InsertPopupText'
  END
      #ENDIF
      #IF(%EditControl)
        #INSERT(%AddIconToPopup,%EditControl,%TreeControl,%OtherPopupIconChange,%TypeAddPopupIconChange)
  IF ~%EditControl{PROP:Disable}
    %InstancePrefix:PopupText = CLIP(%InstancePrefix:PopupText) & '|' & %ValueConstruct & '%'ChangePopupText'
  ELSE
    %InstancePrefix:PopupText = CLIP(%InstancePrefix:PopupText) & '|~' & %ValueConstruct & '%'ChangePopupText'
  END
      #ENDIF
      #IF(%RemoveControl)
        #INSERT(%AddIconToPopup,%RemoveControl,%TreeControl,%OtherPopupIconDelete,%TypeAddPopupIconDelete)
  IF ~%RemoveControl{PROP:Disable}
    %InstancePrefix:PopupText = CLIP(%InstancePrefix:PopupText) & '|' & %ValueConstruct & '%'DeletePopupText'
  ELSE
    %InstancePrefix:PopupText = CLIP(%InstancePrefix:PopupText) & '|~' & %ValueConstruct & '%'DeletePopupText'
  END
      #ENDIF
END
    #ENDIF
  #ENDIF
#ENDAT
#AT(%SingleFileTreeEditPopUpHandling)
  #IF(%EditViaPopup)
    #IF(%Control=%TreeControl)
      #IF(%AddControl)
IF ~%AddControl{PROP:Disable}
  POST(Event:Accepted,%AddControl)
END
      #ENDIF
      #IF(%EditControl)
IF ~%EditControl{PROP:Disable}
  POST(Event:Accepted,%EditControl)
END
      #ENDIF
      #IF(%RemoveControl)
IF ~%RemoveControl{PROP:Disable}
  POST(Event:Accepted,%RemoveControl)
END
      #ENDIF
    #ENDIF
  #ENDIF
#ENDAT
#!----------------------------------------------------------------
#CONTROL(SingleFileTreeSelectButton,'      '),DESCRIPTION('    ' & %Primary),REQ(SingleFileTree),FIRST
  CONTROLS
    BUTTON('&'),USE(?Select)
  END
#BOXED(' ""')
  #PROMPT('&  ',CHECK),%HideIfDisabled,AT(10,,150)
  #PROMPT('&   Popup-',CHECK),%SelectViaPopup,DEFAULT(1),AT(10,,150)
  #ENABLE(%SelectViaPopup)
    #PROMPT('  Popup-:',DROP('  || ')),%TypeAddPopupIcon,DEFAULT('  '),PROMPTAT(,,110),AT(,,70)
    #ENABLE(%TypeAddPopupIcon = ''),CLEAR
      #PROMPT(':',@S40),%OtherPopupIcon,REQ
    #ENDENABLE
  #ENDENABLE
#ENDBOXED
#ATSTART
  #DECLARE(%SelectControl)
  #DECLARE(%SelectText)
  #FOR(%Control),WHERE(%ControlInstance = %ActiveTemplateInstance)
    #SET(%SelectControl,%Control)
    #IF(%SelectViaPopup)
      #SET(%SelectText,EXTRACT(%ControlStatement,'BUTTON',1))
      #SET(%SelectText,SUB(%SelectText,2,LEN(%SelectText)-2))
    #ENDIF
  #ENDFOR
#ENDAT
#!
#AT(%PrepareAlerts)
%TreeControl{Prop:Alrt,253} = MouseLeft2
#ENDAT
#AT(%AlertKeySingleFileTreeDoubleClick)
  #IF(%SelectControl)
    #IF(%Control=%TreeControl)
IF Self.Request = SelectRecord
  IF ~%SelectControl{PROP:Disable}
    POST(Event:Accepted,%SelectControl)
    CYCLE
  END
END
    #ENDIF
  #ENDIF
#ENDAT
#AT(%AfterWindowOpening)
#FIX(%Control,%TreeControl)
  #IF(%SelectControl)
IF Self.Request <> SelectRecord
    #IF(%HideIfDisabled)
  %SelectControl{Prop:Hide} = True
    #ENDIF
  DISABLE(%SelectControl)
ELSE
    #IF(%TreeTitle)
#!  DISABLE(%SelectControl)
#!    #ELSE
  %SelectControl{Prop:Default} = True
  ENABLE(%SelectControl)
    #ENDIF
END
  #ENDIF
#ENDAT
#AT(%SingleFileTreeSelectPopUp)
  #IF(%SelectControl AND %SelectViaPopup)
    #IF(%Control=%TreeControl)
      #IF(%TreeTitle)
        #SET(%ValueConstruct,1)
      #ELSE
        #SET(%ValueConstruct,0)
      #ENDIF
IF %InstancePrefix:PopupText THEN %InstancePrefix:PopupText = CLIP(%InstancePrefix:PopupText) & '|-|'.
IF RECORDS(%TreeQueue) > %ValueConstruct
      #INSERT(%AddIconToPopup,%SelectControl,%TreeControl,%OtherPopupIcon,%TypeAddPopupIcon)
  IF ~%SelectControl{PROP:Disable}
    %InstancePrefix:PopupText = CLIP(%InstancePrefix:PopupText) & %ValueConstruct & '%'SelectText'
  ELSE
    %InstancePrefix:PopupText = CLIP(%InstancePrefix:PopupText) & '~' & %ValueConstruct & '%'SelectText'
  END
ELSE
  %InstancePrefix:PopupText = CLIP(%InstancePrefix:PopupText) & '~' & %ValueConstruct & '%'SelectText'
END
    #ENDIF
  #ENDIF
#ENDAT
#AT(%SingleFileTreeSelectPopUpHandling)
  #IF(%SelectControl AND %SelectViaPopup)
    #IF(%Control=%TreeControl)
IF ~%SelectControl{PROP:Disable}
  POST(Event:Accepted,%SelectControl)
END
    #ENDIF
  #ENDIF
#ENDAT
#AT(%ControlEventHandling,%SelectControl,'Accepted')
  #IF(%SelectControl)
#EMBED(%SingleFileTreeProcessSelected,'    ')
Self.Response = RequestCompleted
POST(Event:CloseWindow)
  #ENDIF
#ENDAT
#AT(%SingleFileTreeNewSelection)
  #IF(%SelectControl AND %SelectViaPopup)
    #IF(%TreeTitle)
      #SET(%ValueConstruct,1)
    #ELSE
      #SET(%ValueConstruct,0)
    #ENDIF
IF ThisWindow.Request = SelectRecord
  IF RECORDS(%TreeQueue) > %ValueConstruct
    #IF(%ValueConstruct = 1)
    IF %InstancePrefix:CurrentChoice > 1
      %SelectControl{Prop:Default} = True
      ENABLE(%SelectControl)
    ELSE
      DISABLE(%SelectControl)
    END
    #ELSE
    %SelectControl{Prop:Default} = True
    ENABLE(%SelectControl)
    #ENDIF
  ELSE
    DISABLE(%SelectControl)
  END
END
  #ENDIF
#ENDAT
